﻿using jnbridge.jmsadapter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using WcfJmsPublisher;

namespace WcfJmsListener
{
    [ServiceBehavior(Namespace = "jms://JNBridge.JMSAdapter/Service")]
    public class WcfJmsSvc : IWcfJmsSvc
    {
        JNBridgeJmsAdapterClient client = null;

        public bool MessageAvailable()
        {
           return (WcfJmsListenerService.messages.IsEmpty == false);
        }

        public JMSMessage GetMessage()
        {
            JMSMessage aMessage;
            WcfJmsListenerService.messages.TryDequeue(out aMessage);
            return aMessage;
        }

        public void PublishMessage(string destination, string text)
        {
            if (client == null)
            {
                client = new JNBridgeJmsAdapterClient();
            }
            client.SendText(destination, text);
        }
    }

    public class JMSMessage
    {
        private string messageText;
        private JMSMessageHeader messageHeader;

        public string Text
        {
            get { return messageText; }
            set { this.messageText = value; }
        }

        public JMSMessageHeader Header
        {
            get { return messageHeader; }
            set { this.messageHeader = value; }
        }
    }
}